﻿using UnityEngine;
using System.Collections;

public class SquadControl : MonoBehaviour {

    private VirtualLeader mLeader;
    private LayerMask mTerrainMask;

	// Use this for initialization
	void Start ()
	{
        mLeader = GameObject.FindGameObjectWithTag("Virtual Leader").GetComponent<VirtualLeader>();

        //make terrain layer mask
        mTerrainMask = 1 << LayerMask.NameToLayer("Terrain");
	}

	// Update is called once per frame
	void Update () 
	{
        CheckForMoveRequest();
	}

    /// <summary>
    /// Checks for and executes a move request from the player
    /// </summary>
    private void CheckForMoveRequest()
    {
        if (Input.GetMouseButtonDown(0))
        {
            Ray camRay = Camera.main.ScreenPointToRay(Input.mousePosition);
            RaycastHit hit;
            Physics.Raycast(camRay, out hit, Mathf.Infinity, mTerrainMask);

            if (hit.collider != null)
            {
                mLeader.MoveTo(hit.point);
            }
        }
    }
}
